#!/bin/bash
# Submission script for Blake
#SBATCH --job-name=MC_MG
#SBATCH --time=41:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p blake
#
#SBATCH --comment=test
#SBATCH --output=workspace/MC_MG.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=48
export KMP_PLACE_THREADS=24c,2t
export KMP_AFFINITY=compact

export MKL_NUM_THREADS=${OMP_NUM_THREADS}

python run.py -k ${OMP_NUM_THREADS} katoptron/CMAME/tests/plate_MC_MG_all_cases_2.py
