import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import axes3d
import matplotlib.tri as mtri

from katoptron.Juelich.UQ.kde import *
import katoptron.utilities as u
from numpy import linalg as LA


def compute_qoi(base_dir, ensemble_size, ensemble_index, l):
    OAX, OAY = 0.0595, 0.017
    npzfile = np.load(base_dir + str(ensemble_size) + '/' +
                      str(ensemble_index) + '/mirror_data_all.npz')
    x = npzfile['x']
    y = npzfile['y']
    z = 0. * x
    dz = npzfile['dz']
    T = npzfile['T']
    tri = npzfile['tri']

    fig = plt.figure()
    axtri = plt.tricontourf(x, y, tri, T[:, l], vmin=330., vmax=375.)
    cb = fig.colorbar(axtri, orientation="horizontal")
    return x, y, tri, T[:, l]


def main():

    N = 8
    # '/Volumes/HD_SONY/juelich/k_conductivity/QoI_results_7/'
    base_dir = '/Users/kimliegeois/Desktop/QoI_results_7/'
    n_qoi = 5
    n_rand = 3
    ensemble_size = 1

    optical_coefficients_all = np.zeros((n_qoi, N))
    random_variables = np.zeros((n_rand, N))

    ensemble_size = 1
    N_ensemble = N // ensemble_size
    for ensemble_index in range(0, N_ensemble):
        for l in range(0, ensemble_size):
            x, y, tri, dz = compute_qoi(base_dir, ensemble_size,
                                        ensemble_index, l)
            if l == 0 and ensemble_index == 0:
                dz_1 = dz.reshape((len(dz), 1))
            else:
                dz_1 = np.append(dz_1, dz.reshape((len(dz), 1)), axis=1)
    ensemble_size = 8
    N_ensemble = N // ensemble_size
    for ensemble_index in range(0, N_ensemble):
        for l in range(0, ensemble_size):
            x, y, tri, dz = compute_qoi(base_dir, ensemble_size,
                                        ensemble_index, l)
            if l == 0 and ensemble_index == 0:
                dz_8 = dz.reshape((len(dz), 1))
            else:
                dz_8 = np.append(dz_8, dz.reshape((len(dz), 1)), axis=1)

    for i in range(0, N):
        #fig = plt.figure()
        #axtri = plt.tricontourf(x, y, tri, np.abs(dz_1[:,i]-dz_8[:,i])/dz_1[:,i] )
        #cb = fig.colorbar(axtri, orientation="horizontal")
        print(LA.norm(dz_1[:, i] - dz_8[:, i]))
        print(LA.norm(dz_1[:, i]))
        print((LA.norm(dz_1[:, i] - dz_8[:, i]) / LA.norm(dz_1[:, i])))
        print('-----')
    plt.show()


if __name__ == "__main__":
    main()
