function [it, res] = read_belos(filename)

    it = [];
    res = [];

    fid = fopen(filename);

    tline = fgetl(fid);
    while ischar(tline)
        current_length = length(tline);
        if current_length > 5
            if tline(1:4) == 'Iter'             
                % get the iteration id
                i_1 = 5;
                i_2 = 5;
                while tline(i_2) ~= ','
                    i_2 = i_2+1;
                end
                it = [it, str2num(tline(i_1:i_2-1))];    
                
                % get the res
                i_1 = i_2;
                i_2 = current_length;
                while tline(i_1) ~= ':'
                    i_1 = i_1+1;
                end
                res = [res, str2num(tline(i_1+1:i_2))];                   
            end
        end
        tline = fgetl(fid);
    end
    
    figure
    semilogy(it,res,'*')
    grid on
    box on
    set(gca,'fontsize',18)
    xlabel('Iteration')
    ylabel('(2-Norm Res Vec) / (2-Norm Prec Res0)')
end