SetFactory("OpenCASCADE");

LX = 10;
lx = 2;
LY = 10;
ly = 2;
LZ = 2;

nR1 = 5;

R = 1.;
R2 = 1.;
R_in_1 = 0.4;
R_in_2 = 0.5;

nR = 14;
nT1 = 7;

nZ1 = 5;

nZ2 = 4;
nl = 5;
nLX=5;
nLY=10;
nR2=5;

PI = Acos (-1.);

dtheta = 0.1*PI;

lc = 1;
Point(1)  = { lx,    ly, 0.,     lc};
Point(16)  = { 0,      0, 0,     lc};
Point(17)  = { lx,     0, 0,     lc};
Point(18)  = { 2*lx,     0, 0,     lc};
Point(19)  = { LX,     0, 0,     lc};
Point(20)  = { LX,    ly, 0,     lc};
Point(21)  = { 2*lx,  ly, 0,     lc};
Point(22)  = { lx+R2*Cos(0*PI),  ly+R2*Sin(0*PI), 0,     lc};
Point(23)  = { lx+R2*Cos(-1*PI/4+dtheta),  ly+R2*Sin(-1*PI/4+dtheta), 0,     lc};
Point(24)  = { lx+R2*Cos(-2*PI/4+dtheta),  ly+R2*Sin(-2*PI/4+dtheta), 0,     lc};
Point(25)  = { lx+R2*Cos(-3*PI/4+dtheta),  ly+R2*Sin(-3*PI/4+dtheta), 0,     lc};
Point(26)  = { lx+R2*Cos(-4*PI/4-dtheta),  ly+R2*Sin(-4*PI/4-dtheta), 0,     lc};
Point(27)  = { lx+R2*Cos(-5*PI/4-dtheta),  ly+R2*Sin(-5*PI/4-dtheta), 0,     lc};
Point(28)  = { lx+R2*Cos(-6*PI/4),  ly+R2*Sin(-6*PI/4), 0,     lc};
Point(29)  = { lx,    2*ly, 0,     lc};
Point(30)  = { lx,    LY, 0,     lc};
Point(31)  = { 0,    LY, 0,     lc};
Point(32)  = { 0,    2*ly, 0,     lc};
Point(33)  = { 0,    ly, 0,     lc};


//+
Line(255) = {16, 17};
//+
Line(256) = {17, 18};
//+
Line(257) = {18, 19};
//+
Line(258) = {19, 20};
//+
Line(259) = {20, 21};
//+
Line(260) = {16, 33};
//+
Line(261) = {33, 32};
//+
Line(262) = {32, 31};
//+
Line(263) = {31, 30};
//+
Line(264) = {30, 29};
//+
Line(265) = {17, 24};
//+
Line(266) = {16, 25};
//+
Line(267) = {18, 23};
//+
Line(268) = {22, 21};
//+
Line(269) = {26, 33};
//+
Line(270) = {27, 32};
//+
Line(271) = {28, 29};
//+
Circle(272) = {22, 1, 23};
//+
Circle(273) = {23, 1, 24};
//+
Circle(274) = {24, 1, 25};
//+
Circle(275) = {25, 1, 26};
//+
Circle(276) = {26, 1, 27};
//+
Circle(277) = {27, 1, 28};
//+
Line(278) = {18, 21};
//+
Line(279) = {29, 32};

Transfinite Line {263, 279, 277, 258, 278, 272, 273, 256, 255, 274, 260, 275, 276, 261} = nl Using Progression 1;
Transfinite Line {271, 270, 269, 266, 265, 267, 268} = nR2 Using Progression 1;
Transfinite Line {257, 259} = nLX Using Progression 1;
Transfinite Line {264, 262} = nLY Using Progression 1;


Line Loop(10) = {277, 271, 279, -270};
Plane Surface(10) = {10};

Transfinite Surface {10};
Recombine Surface {10};

Line Loop(11) = {276, 270, -261, -269};
Plane Surface(11) = {11};
Transfinite Surface {11};
Recombine Surface {11};

Line Loop(12) = {266, 275, 269, -260};
Plane Surface(12) = {12};
Transfinite Surface {12};
Recombine Surface {12};

Line Loop(13) = {266, -274, -265, -255};
Plane Surface(13) = {13};
Transfinite Surface {13};
Recombine Surface {13};

Line Loop(14) = {265, -273, -267, -256};
Plane Surface(14) = {14};
Transfinite Surface {14};
Recombine Surface {14};

Line Loop(15) = {267, -272, 268, -278};
Plane Surface(15) = {15};
Transfinite Surface {15};
Recombine Surface {15};

Line Loop(16) = {278, -259, -258, -257};
Plane Surface(16) = {16};
Transfinite Surface {16};
Recombine Surface {16};

Line Loop(17) = {279, 262, 263, 264};
Plane Surface(17) = {17};
Transfinite Surface {17};
Recombine Surface {17};

Extrude {0, 0, LZ}
{
  Surface{10,11,12,13,14,15,16,17}; Layers{nZ2}; Recombine;
}

Physical Volume("body") = {1,2,3,4,5,6,7,8};
//+
Physical Surface("clamping") = {48};
//+
Physical Surface("load") = {44};
//+
Physical Surface("outer part boundary") = {18, 23, 28, 31, 39, 35};
//Physical Surface("outer part boundary") = {18};
