#!/bin/bash
# Submission script for Blake
#SBATCH --job-name=test_6
#SBATCH --time=41:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p blake
#
#SBATCH --comment=test
#SBATCH --output=workspace/test_6.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=24
export KMP_HW_SUBSET=24c,1t
export KMP_AFFINITY=compact

base_dir=$(pwd)
geo_file=${base_dir}/katoptron/thesis/test_6/1_cube.geo
msh_file=${base_dir}/workspace/katoptron_thesis_test_6_1_cube/1_cube.msh

if [ ! -d ${base_dir}/workspace/katoptron_thesis_test_6_1_cube ] 
then
    mkdir ${base_dir}/workspace/katoptron_thesis_test_6_1_cube
fi

workspace/thesis_tests_test_6_1_cube

gmsh -3 -format msh2 -setnumber nCx 49 -setnumber nCy 49 -setnumber nCz 49 -o ${msh_file} ${geo_file} -format msh22

export max_iter=200

export test_id=1
export ensemble_size=1
export MKL_NUM_THREADS=1
export OMP_NUM_THREADS=1
python run.py -k 1 katoptron/thesis/test_6/1_cube.py

export test_id=2
export ensemble_size=1
export MKL_NUM_THREADS=24
export OMP_NUM_THREADS=24
python run.py -k 24 katoptron/thesis/test_6/1_cube.py

export test_id=3
export ensemble_size=8
export MKL_NUM_THREADS=24
export OMP_NUM_THREADS=24
python run.py -k 24 katoptron/thesis/test_6/1_cube.py

export test_id=4
export ensemble_size=1
export MKL_NUM_THREADS=1
export OMP_NUM_THREADS=1
#mpirun -npersocket 1 python run.py -k 1 katoptron/thesis/test_6/1_cube.py
#mpirun --report-bindings --bind-to core --map-by ppr:24:socket:pe=1 python run.py -k 1 katoptron/thesis/test_6/1_cube.py &> log.txt
mpirun --bind-to core --map-by ppr:24:socket:pe=1 python run.py -k 1 katoptron/thesis/test_6/1_cube.py
