/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WMSHCONVERT_H
#define WMSHCONVERT_H

#include "tbox.h"
#include "wObject.h"
#include "wMshData.h"
#include <memory>

namespace tbox
{

/**
 * @brief Mesh converter
 * @authors Adrien Crovato, Kim Liegeois
 * @todo might need cleaning
 */
class TBOX_API MshConvert : public fwk::wSharedObject
{
    int searchCode(char const *code, char const *line) const;

public:
    std::shared_ptr<MshData> msh;

    MshConvert(std::shared_ptr<MshData> _msh);
    virtual ~MshConvert() {}

    void ansys_gmsh(std::string const &fname1, std::string const &fname2);
};

} // namespace tbox

#endif //WMSHCONVERT_H